import java.util.ArrayList;

import it.kibo.fp.lib.RandomDraws;

public class Giocatore {
    private String nome;
    private int sbleuri;
    private int tessereSbleuri;
    private boolean cavaliere;
    //ho pensato di renderlo un boolean perché disponibile una volta per tappa, poi la richiesta se è tifo o inveimento sarà nel metodo
    private boolean tesseraTifoInveimento; 
    private ArrayList <Carta> carte = new ArrayList<>();

    public Giocatore(String nome, ArrayList <Carta> carte){
        this.nome = nome;
        this.sbleuri = 3;
        tessereSbleuri = 0;
        cavaliere = false;
        tesseraTifoInveimento = true;
        this.carte = carte;
    }


    //getters
    public String getNome() {
        return nome;
    }
    public int getSbleuri() {
        return sbleuri;
    }
    public int getTessereSbleuri() {
        return tessereSbleuri;
    }
    public boolean isCavaliere() {
        return cavaliere;
    }
    public boolean isTesseraTifoInveimento() {
        return tesseraTifoInveimento;
    }

    //setters
    public void setNome(String nome) {
        this.nome = nome;
    }
    public void setSbleuri(int x){
        this.sbleuri = x;
    }
    public void setTessereSbleuri(int tessereSbleuri) {
        this.tessereSbleuri = tessereSbleuri;
    }
    public void setCavaliere(boolean cavaliere) {
        this.cavaliere = cavaliere;
    }
    public void setTesseraTifoInveimento(boolean tesseraTifoInveimento) {
        this.tesseraTifoInveimento = tesseraTifoInveimento;
    }

    public void convertiTessereSbleuro(){
        this.sbleuri += this.tessereSbleuri;
    }

    public int posizionaTesseraTifoInveimento(Mappa mappa){
        int i = new Input().sceltaTifoInvimento(mappa);
        boolean s = new Input().sceltaTifoInveimento();
        if (s == true){
            mappa.getCasella(i).setTifoInveimento(1);
        }
        else{
            mappa.getCasella(i).setTifoInveimento(-1);
        }
        return i;
    }

    public void lanciaDado(ArrayList <Cavallo> cavalli, Mappa mappa){
        int i = RandomDraws.drawInteger(0, 6);
        int m = RandomDraws.drawInteger(1, 3);
        mappa.movimentoCavalli(cavalli.get(i), m, mappa);
        tessereSbleuri += 1;
    }

    public void scommettiCavallo(Cavallo cavallo){
        cavallo.aggiungiTessera(this);
    }

    public Carta getCarta(int i){
        return carte.get(i);
    }

    public void giocaCasa(int i, Pila p){
        boolean s = new Input().vincitorePerdente();
        if (s == true){
            p.aggiungiVincitori(carte.get(i));
        }else{
            p.aggiungiPerdenti(carte.get(i));
        }
        
    }

}
